/* File: message.h */

#ifndef MESSAGE_H
#define	MESSAGE_H

#define PAGE_SIZE 4096

typedef enum message_id
{
    GETFILES, 
    EXPECT, 
    PROCESSFILE,
    FILEINFO,
    GETDATA,
    DATA,
    ERROR,
    CALCULATE_HASH
}message_id;

typedef struct message
{
    message_id id;
    int expect_num;
    int filesize;
    int pageno;    
    char *error;
    char *directory;
    char *filename;    
    char *pagedata;    
    unsigned int **hash_tree;
}message;

#endif	/* MESSAGE_H */

