/* File: queue.h */

#ifndef QUEUE_H
#define	QUEUE_H


#include <stdio.h>
#include <stdlib.h>
#include "message.h"


typedef struct qnode* qnode_ptr;
typedef struct qhead* qhead_ptr;

typedef struct qnode
{ 
    int socket;
    message msg;
    qnode_ptr next;
}qnode;

typedef struct qhead
{
    qnode_ptr first;
    qnode_ptr last;
    int size;
}qhead;


/*desmeuei kai arxikopoiei tin kefali tis ouras*/
int queue_init(qhead_ptr *qhead);
/*eisagei to stoixeio new_node stin oura qhead*/
void queue_insert(qhead_ptr qhead, qnode_ptr new_node);
/*exagagei apo tin oura qhead to proto stoixeio*/
qnode_ptr queue_extract(qhead_ptr qhead);
/*elengxei an i oura den einai keni*/
int queue_not_empty(qhead_ptr qhead);
/*typonei ta stoixeia tis listas*/
void queue_print(qhead_ptr qhead);


#endif	/* QUEUE_H */

